<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head profile="http://dublincore.org/documents/2008/08/04/dc-html/">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta name="robots" content="index,follow" />
    <meta name="creator" content="rfcmarkup version 1.119" />
    <link rel="schema.DC" href="http://purl.org/dc/elements/1.1/" />
<meta name="DC.Relation.Replaces" content="draft-saintandre-xmpp-address" />
<meta name="DC.Identifier" content="urn:ietf:rfc:6122" />
<meta name="DC.Date.Issued" content="March, 2011" />
<meta name="DC.Creator" content="Peter Saint-Andre &lt;psaintan@cisco.com&gt;" />
<meta name="DC.Description.Abstract" content="This document defines the format for addresses used in the Extensible
Messaging and Presence Protocol (XMPP), including support for non-
ASCII characters. This document updates RFC 3920. [STANDARDS-TRACK]" />
<meta name="DC.Title" content="Extensible Messaging and Presence Protocol (XMPP): Address Format" />

    <link rel="icon" href="/images/rfc.png" type="image/png" />
    <link rel="shortcut icon" href="/images/rfc.png" type="image/png" />
    <title>RFC 6122 - Extensible Messaging and Presence Protocol (XMPP): Address Format</title>
    
    
    <style type="text/css">
	@media only screen 
	  and (min-width: 992px)
	  and (max-width: 1199px) {
	    body { font-size: 14pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-width: 768px)
	  and (max-width: 991px) {
            body { font-size: 14pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-width: 480px)
	  and (max-width: 767px) {
            body { font-size: 11pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (max-width: 479px) {
            body { font-size: 8pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-device-width : 375px) 
	  and (max-device-width : 667px) {
            body { font-size: 9.5pt; }
            div.content { width: 96ex; margin: 0 1px; }
        }
	@media only screen 
	  and (min-device-width: 1200px) {
            body { font-size: 10pt; margin: 0 4em; }
            div.content { width: 96ex; margin: 0; }
        }
        h1, h2, h3, h4, h5, h6, .h1, .h2, .h3, .h4, .h5, .h6 {
	    font-weight: bold;
            line-height: 0pt;
            display: inline;
            white-space: pre;
            font-family: monospace;
            font-size: 1em;
	    font-weight: bold;
        }
        pre {
            font-size: 1em;
            margin-top: 0px;
            margin-bottom: 0px;
        }
	.pre {
	    white-space: pre;
	    font-family: monospace;
	}
	.header{
	    font-weight: bold;
	}
        .newpage {
            page-break-before: always;
        }
        .invisible {
            text-decoration: none;
            color: white;
        }
        a.selflink {
          color: black;
          text-decoration: none;
        }
        @media print {
            body {
                font-family: monospace;
                font-size: 10.5pt;
            }
            h1, h2, h3, h4, h5, h6 {
                font-size: 1em;
            }
        
            a:link, a:visited {
                color: inherit;
                text-decoration: none;
            }
            .noprint {
                display: none;
            }
        }
	@media screen {
	    .grey, .grey a:link, .grey a:visited {
		color: #777;
	    }
            .docinfo {
                background-color: #EEE;
            }
            .top {
                border-top: 7px solid #EEE;
            }
            .bgwhite  { background-color: white; }
            .bgred    { background-color: #F44; }
            .bggrey   { background-color: #666; }
            .bgbrown  { background-color: #840; }            
            .bgorange { background-color: #FA0; }
            .bgyellow { background-color: #EE0; }
            .bgmagenta{ background-color: #F4F; }
            .bgblue   { background-color: #66F; }
            .bgcyan   { background-color: #4DD; }
            .bggreen  { background-color: #4F4; }

            .legend   { font-size: 90%; }
            .cplate   { font-size: 70%; border: solid grey 1px; }
	}
    </style>
    <!--[if IE]>
    <style>
    body {
       font-size: 13px;
       margin: 10px 10px;
    }
    </style>
    <![endif]-->

    <script type="text/javascript"><!--
    function addHeaderTags() {
	var spans = document.getElementsByTagName("span");
	for (var i=0; i < spans.length; i++) {
	    var elem = spans[i];
	    if (elem) {
		var level = elem.getAttribute("class");
                if (level == "h1" || level == "h2" || level == "h3" || level == "h4" || level == "h5" || level == "h6") {
                    elem.innerHTML = "<"+level+">"+elem.innerHTML+"</"+level+">";		
                }
	    }
	}
    }
    var legend_html = "Colour legend:<br />      <table>         <tr><td>Unknown:</td>                   <td><span class='cplate bgwhite'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Draft:</td>                     <td><span class='cplate bgred'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Informational:</td>             <td><span class='cplate bgorange'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Experimental:</td>              <td><span class='cplate bgyellow'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Best Common Practice:</td>      <td><span class='cplate bgmagenta'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Proposed Standard:</td>         <td><span class='cplate bgblue'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Draft Standard (old designation):</td> <td><span class='cplate bgcyan'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Internet Standard:</td>         <td><span class='cplate bggreen'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Historic:</td>                  <td><span class='cplate bggrey'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Obsolete:</td>                  <td><span class='cplate bgbrown'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>     </table>";
    function showElem(id) {
        var elem = document.getElementById(id);
        elem.innerHTML = eval(id+"_html");
        elem.style.visibility='visible';
    }
    function hideElem(id) {
        var elem = document.getElementById(id);
        elem.style.visibility='hidden';        
        elem.innerHTML = "";
    }
    // -->
    </script>
</head>
<body onload="addHeaderTags()">
  <div class="content">
   <div style="height: 13px;">
      <div onmouseover="this.style.cursor='pointer';"
         onclick="showElem('legend');"
         onmouseout="hideElem('legend')"
	 style="height: 6px; position: absolute;"
         class="pre noprint docinfo bgbrown"
         title="Click for colour legend." >                                                                        </div>
      <div id="legend"
           class="docinfo noprint pre legend"
           style="position:absolute; top: 4px; left: 4ex; visibility:hidden; background-color: white; padding: 4px 9px 5px 7px; border: solid #345 1px; "
           onmouseover="showElem('legend');"
           onmouseout="hideElem('legend');">
      </div>
   </div>
<span class="pre noprint docinfo top">[<a href="../html/" title="Document search and retrieval page">Docs</a>] [<a href="/rfc/rfc6122.txt" title="Plaintext version of this document">txt</a>|<a href="/pdf/rfc6122" title="PDF version of this document">pdf</a>] [<a href="./draft-ietf-xmpp-address" title="draft-ietf-xmpp-address">draft-ietf-xmpp-a...</a>] [<a href="/rfcdiff?difftype=--hwdiff&amp;url2=rfc6122" title="Inline diff (wdiff)">Diff1</a>] [<a href="/rfcdiff?url2=rfc6122" title="Side-by-side diff">Diff2</a>] [<a href="https://www.rfc-editor.org/errata_search.php?rfc=6122">Errata</a>]        </span><br />
<span class="pre noprint docinfo">                                                                        </span><br />
<span class="pre noprint docinfo">Obsoleted by: <a href="./rfc7622">7622</a>                                     PROPOSED STANDARD</span><br />
<span class="pre noprint docinfo">                                                            <span style='color: #C00;'>Errata Exist</span></span><br />
<pre>
Internet Engineering Task Force (IETF)                    P. Saint-Andre
Request for Comments: 6122                                         Cisco
Updates: <a href="./rfc3920">3920</a>                                                 March 2011
Category: Standards Track
ISSN: 2070-1721


   <span class="h1">Extensible Messaging and Presence Protocol (XMPP): Address Format</span>

Abstract

   This document defines the format for addresses used in the Extensible
   Messaging and Presence Protocol (XMPP), including support for
   non-ASCII characters.  This document updates <a href="./rfc3920">RFC 3920</a>.

Status of This Memo

   This is an Internet Standards Track document.

   This document is a product of the Internet Engineering Task Force
   (IETF).  It represents the consensus of the IETF community.  It has
   received public review and has been approved for publication by the
   Internet Engineering Steering Group (IESG).  Further information on
   Internet Standards is available in <a href="./rfc5741#section-2">Section&nbsp;2 of RFC 5741</a>.

   Information about the current status of this document, any errata,
   and how to provide feedback on it may be obtained at
   <a href="http://www.rfc-editor.org/info/rfc6122">http://www.rfc-editor.org/info/rfc6122</a>.

Copyright Notice

   Copyright (c) 2011 IETF Trust and the persons identified as the
   document authors.  All rights reserved.

   This document is subject to <a href="./bcp78">BCP 78</a> and the IETF Trust's Legal
   Provisions Relating to IETF Documents
   (<a href="http://trustee.ietf.org/license-info">http://trustee.ietf.org/license-info</a>) in effect on the date of
   publication of this document.  Please review these documents
   carefully, as they describe your rights and restrictions with respect
   to this document.  Code Components extracted from this document must
   include Simplified BSD License text as described in Section 4.e of
   the Trust Legal Provisions and are provided without warranty as
   described in the Simplified BSD License.








<span class="grey">Saint-Andre                  Standards Track                    [Page 1]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-2" id="page-2" href="#page-2" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


Table of Contents

   <a href="#section-1">1</a>.  Introduction . . . . . . . . . . . . . . . . . . . . . . . . .  <a href="#page-3">3</a>
     <a href="#section-1.1">1.1</a>.  Overview . . . . . . . . . . . . . . . . . . . . . . . . .  <a href="#page-3">3</a>
     <a href="#section-1.2">1.2</a>.  Terminology  . . . . . . . . . . . . . . . . . . . . . . .  <a href="#page-4">4</a>
   <a href="#section-2">2</a>.  Addresses  . . . . . . . . . . . . . . . . . . . . . . . . . .  <a href="#page-4">4</a>
     <a href="#section-2.1">2.1</a>.  Fundamentals . . . . . . . . . . . . . . . . . . . . . . .  <a href="#page-4">4</a>
     <a href="#section-2.2">2.2</a>.  Domainpart . . . . . . . . . . . . . . . . . . . . . . . .  <a href="#page-6">6</a>
     <a href="#section-2.3">2.3</a>.  Localpart  . . . . . . . . . . . . . . . . . . . . . . . .  <a href="#page-7">7</a>
     <a href="#section-2.4">2.4</a>.  Resourcepart . . . . . . . . . . . . . . . . . . . . . . .  <a href="#page-8">8</a>
   <a href="#section-3">3</a>.  Internationalization Considerations  . . . . . . . . . . . . .  <a href="#page-9">9</a>
   <a href="#section-4">4</a>.  Security Considerations  . . . . . . . . . . . . . . . . . . .  <a href="#page-9">9</a>
     <a href="#section-4.1">4.1</a>.  Reuse of Stringprep  . . . . . . . . . . . . . . . . . . .  <a href="#page-9">9</a>
     <a href="#section-4.2">4.2</a>.  Reuse of Unicode . . . . . . . . . . . . . . . . . . . . .  <a href="#page-9">9</a>
     <a href="#section-4.3">4.3</a>.  Address Spoofing . . . . . . . . . . . . . . . . . . . . .  <a href="#page-9">9</a>
       <a href="#section-4.3.1">4.3.1</a>.  Address Forging  . . . . . . . . . . . . . . . . . . . <a href="#page-10">10</a>
       <a href="#section-4.3.2">4.3.2</a>.  Address Mimicking  . . . . . . . . . . . . . . . . . . <a href="#page-10">10</a>
   <a href="#section-5">5</a>.  IANA Considerations  . . . . . . . . . . . . . . . . . . . . . <a href="#page-13">13</a>
     <a href="#section-5.1">5.1</a>.  Nodeprep Profile of Stringprep . . . . . . . . . . . . . . <a href="#page-13">13</a>
     <a href="#section-5.2">5.2</a>.  Resourceprep Profile of Stringprep . . . . . . . . . . . . <a href="#page-14">14</a>
   <a href="#section-6">6</a>.  Conformance Requirements . . . . . . . . . . . . . . . . . . . <a href="#page-14">14</a>
   <a href="#section-7">7</a>.  References . . . . . . . . . . . . . . . . . . . . . . . . . . <a href="#page-16">16</a>
     <a href="#section-7.1">7.1</a>.  Normative References . . . . . . . . . . . . . . . . . . . <a href="#page-16">16</a>
     <a href="#section-7.2">7.2</a>.  Informative References . . . . . . . . . . . . . . . . . . <a href="#page-17">17</a>
   <a href="#appendix-A">Appendix A</a>.  Nodeprep  . . . . . . . . . . . . . . . . . . . . . . <a href="#page-19">19</a>
     <a href="#appendix-A.1">A.1</a>.  Introduction . . . . . . . . . . . . . . . . . . . . . . . <a href="#page-19">19</a>
     <a href="#appendix-A.2">A.2</a>.  Character Repertoire . . . . . . . . . . . . . . . . . . . <a href="#page-19">19</a>
     <a href="#appendix-A.3">A.3</a>.  Mapping  . . . . . . . . . . . . . . . . . . . . . . . . . <a href="#page-19">19</a>
     <a href="#appendix-A.4">A.4</a>.  Normalization  . . . . . . . . . . . . . . . . . . . . . . <a href="#page-19">19</a>
     <a href="#appendix-A.5">A.5</a>.  Prohibited Output  . . . . . . . . . . . . . . . . . . . . <a href="#page-20">20</a>
     <a href="#appendix-A.6">A.6</a>.  Bidirectional Characters . . . . . . . . . . . . . . . . . <a href="#page-20">20</a>
     <a href="#appendix-A.7">A.7</a>.  Notes  . . . . . . . . . . . . . . . . . . . . . . . . . . <a href="#page-20">20</a>
   <a href="#appendix-B">Appendix B</a>.  Resourceprep  . . . . . . . . . . . . . . . . . . . . <a href="#page-21">21</a>
     <a href="#appendix-B.1">B.1</a>.  Introduction . . . . . . . . . . . . . . . . . . . . . . . <a href="#page-21">21</a>
     <a href="#appendix-B.2">B.2</a>.  Character Repertoire . . . . . . . . . . . . . . . . . . . <a href="#page-22">22</a>
     <a href="#appendix-B.3">B.3</a>.  Mapping  . . . . . . . . . . . . . . . . . . . . . . . . . <a href="#page-22">22</a>
     <a href="#appendix-B.4">B.4</a>.  Normalization  . . . . . . . . . . . . . . . . . . . . . . <a href="#page-22">22</a>
     <a href="#appendix-B.5">B.5</a>.  Prohibited Output  . . . . . . . . . . . . . . . . . . . . <a href="#page-22">22</a>
     <a href="#appendix-B.6">B.6</a>.  Bidirectional Characters . . . . . . . . . . . . . . . . . <a href="#page-22">22</a>
   <a href="#appendix-C">Appendix C</a>.  Differences from <a href="./rfc3920">RFC 3920</a> . . . . . . . . . . . . . . <a href="#page-22">22</a>
   <a href="#appendix-D">Appendix D</a>.  Acknowledgements  . . . . . . . . . . . . . . . . . . <a href="#page-23">23</a>










<span class="grey">Saint-Andre                  Standards Track                    [Page 2]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-3" id="page-3" href="#page-3" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


<span class="h2"><a class="selflink" name="section-1" href="#section-1">1</a>.  Introduction</span>

<span class="h3"><a class="selflink" name="section-1.1" href="#section-1.1">1.1</a>.  Overview</span>

   The Extensible Messaging and Presence Protocol (XMPP) is an
   application profile of the Extensible Markup Language [<a href="#ref-XML" title="&quot;Extensible Markup Language (XML) 1.0 (Fourth Edition)&quot;">XML</a>] for
   streaming XML data in close to real time between any two or more
   network-aware entities.  The address format for XMPP entities was
   originally developed in the Jabber open-source community in 1999,
   first described by [<a href="#ref-XEP-0029" title="&quot;Definition of Jabber Identifiers (JIDs)&quot;">XEP-0029</a>] in 2002, and defined canonically by
   [<a href="./rfc3920" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC3920</a>] in 2004.

   As specified in <a href="./rfc3920">RFC 3920</a>, the XMPP address format reuses the
   "stringprep" technology for preparation of non-ASCII characters
   [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>], including the Nameprep profile for internationalized
   domain names as specified in [<a href="#ref-NAMEPREP" title="&quot;Nameprep: A Stringprep Profile for Internationalized Domain Names (IDN)&quot;">NAMEPREP</a>] and [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>] along with two
   XMPP-specific profiles for the localpart and resourcepart.

   Since the publication of <a href="./rfc3920">RFC 3920</a>, IDNA2003 has been superseded by
   IDNA2008 (see [<a href="#ref-IDNA-PROTO" title="&quot;Internationalized Domain Names in Applications (IDNA): Protocol&quot;">IDNA-PROTO</a>] and related documents), which is not based
   on stringprep.  Following the lead of the IDNA community, other
   technology communities that use stringprep have begun discussions
   about migrating away from stringprep toward more "modern" approaches.
   The XMPP community is participating in those discussions (mostly
   within the PRECIS Working Group) in order to find a replacement for
   the Nodeprep and Resourceprep profiles of stringprep defined in <a href="./rfc3920">RFC</a>
   <a href="./rfc3920">3920</a>.  Because all other aspects of revised documentation for XMPP
   have been incorporated into [<a href="#ref-XMPP" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">XMPP</a>], the XMPP Working Group decided to
   temporarily split the XMPP address format into a separate document so
   as not to significantly delay publication of improved documentation
   for XMPP.  It is expected that this document will be obsoleted as
   soon as work on a new approach to preparation and comparison of
   internationalized addresses has been completed.

   Therefore, this specification provides corrected documentation of the
   XMPP address format using the internationalization technologies
   available in 2004 (when <a href="./rfc3920">RFC 3920</a> was published).  Although this
   document normatively references [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>] and [<a href="#ref-NAMEPREP" title="&quot;Nameprep: A Stringprep Profile for Internationalized Domain Names (IDN)&quot;">NAMEPREP</a>], XMPP
   software implementations are encouraged to begin migrating to
   IDNA2008 (see [<a href="#ref-IDNA-PROTO" title="&quot;Internationalized Domain Names in Applications (IDNA): Protocol&quot;">IDNA-PROTO</a>] and related documents) because the
   specification that obsoletes this one will use IDNA2008 rather than
   IDNA2003.

   This document updates <a href="./rfc3920">RFC 3920</a>.







<span class="grey">Saint-Andre                  Standards Track                    [Page 3]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-4" id="page-4" href="#page-4" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


<span class="h3"><a class="selflink" name="section-1.2" href="#section-1.2">1.2</a>.  Terminology</span>

   Many important terms used in this document are defined in [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>],
   [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>], [<a href="#ref-UNICODE" title="&quot;The Unicode Standard, Version 3.2.0&quot;">UNICODE</a>], and [<a href="#ref-XMPP" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">XMPP</a>].

   The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
   "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and
   "OPTIONAL" in this document are to be interpreted as described in <a href="./rfc2119">RFC</a>
   <a href="./rfc2119">2119</a> [<a href="#ref-KEYWORDS" title="&quot;Key words for use in RFCs to Indicate Requirement Levels&quot;">KEYWORDS</a>].

<span class="h2"><a class="selflink" name="section-2" href="#section-2">2</a>.  Addresses</span>

<span class="h3"><a class="selflink" name="section-2.1" href="#section-2.1">2.1</a>.  Fundamentals</span>

   An XMPP entity is anything that is network-addressable and that can
   communicate using XMPP.  For historical reasons, the native address
   of an XMPP entity is called a Jabber Identifier or JID.  A valid JID
   is a string of [<a href="#ref-UNICODE" title="&quot;The Unicode Standard, Version 3.2.0&quot;">UNICODE</a>] code points, encoded using [<a href="#ref-UTF-8" title="&quot;UTF-8, a transformation format of ISO 10646&quot;">UTF-8</a>], and
   structured as an ordered sequence of localpart, domainpart, and
   resourcepart (where the first two parts are demarcated by the '@'
   character used as a separator, and the last two parts are similarly
   demarcated by the '/' character).

   The syntax for a JID is defined as follows using the Augmented
   Backus-Naur Form as specified in [<a href="#ref-ABNF" title="&quot;Augmented BNF for Syntax Specifications: ABNF&quot;">ABNF</a>].


























<span class="grey">Saint-Andre                  Standards Track                    [Page 4]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-5" id="page-5" href="#page-5" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


      jid           = [ localpart "@" ] domainpart [ "/" resourcepart ]
      localpart     = 1*(nodepoint)
                      ;
                      ; a "nodepoint" is a UTF-8 encoded Unicode code
                      ; point that satisfies the Nodeprep profile of
                      ; stringprep
                      ;
      domainpart    = IP-literal / IPv4address / ifqdn
                      ;
                      ; the "IPv4address" and "IP-literal" rules are
                      ; defined in <a href="./rfc3986">RFC 3986</a>, and the first-match-wins
                      ; (a.k.a. "greedy") algorithm described in RFC
                      ; 3986 applies to the matching process
                      ;
                      ; note well that reuse of the IP-literal rule
                      ; from <a href="./rfc3986">RFC 3986</a> implies that IPv6 addresses are
                      ; enclosed in square brackets (i.e., beginning
                      ; with '[' and ending with ']'), which was not
                      ; the case in <a href="./rfc3920">RFC 3920</a>
                      ;
      ifqdn         = 1*(namepoint)
                      ;
                      ; a "namepoint" is a UTF-8 encoded Unicode
                      ; code point that satisfies the Nameprep
                      ; profile of stringprep
                      ;
      resourcepart  = 1*(resourcepoint)
                      ;
                      ; a "resourcepoint" is a UTF-8 encoded Unicode
                      ; code point that satisfies the Resourceprep
                      ; profile of stringprep
                      ;

   All JIDs are based on the foregoing structure.

   Each allowable portion of a JID (localpart, domainpart, and
   resourcepart) MUST NOT be zero bytes in length and MUST NOT be more
   than 1023 bytes in length, resulting in a maximum total size
   (including the '@' and '/' separators) of 3071 bytes.

   For the purpose of communication over an XMPP network (e.g., in the
   'to' or 'from' address of an XMPP stanza), an entity's address MUST
   be represented as a JID, not as a Uniform Resource Identifier [<a href="#ref-URI" title="&quot;Uniform Resource Identifier (URI): Generic Syntax&quot;">URI</a>]
   or Internationalized Resource Identifier [<a href="#ref-IRI" title="&quot;Internationalized Resource Identifiers (IRIs)&quot;">IRI</a>].  An XMPP IRI
   [<a href="#ref-XMPP-URI" title="&quot;Internationalized Resource Identifiers (IRIs) and Uniform Resource Identifiers (URIs) for the Extensible Messaging and Presence Protocol (XMPP)&quot;">XMPP-URI</a>] is in essence a JID prepended with 'xmpp:'; however, the
   native addressing format used in XMPP is that of a mere JID without a
   URI scheme.  [<a href="#ref-XMPP-URI" title="&quot;Internationalized Resource Identifiers (IRIs) and Uniform Resource Identifiers (URIs) for the Extensible Messaging and Presence Protocol (XMPP)&quot;">XMPP-URI</a>] is provided only for identification and
   interaction outside the context of XMPP itself, for example when



<span class="grey">Saint-Andre                  Standards Track                    [Page 5]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-6" id="page-6" href="#page-6" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   linking to a JID from a web page.  See [<a href="#ref-XMPP-URI" title="&quot;Internationalized Resource Identifiers (IRIs) and Uniform Resource Identifiers (URIs) for the Extensible Messaging and Presence Protocol (XMPP)&quot;">XMPP-URI</a>] for a description
   of the process for securely extracting a JID from an XMPP URI or IRI.

      Implementation Note: When dividing a JID into its component parts,
      an implementation needs to match the separator characters '@' and
      '/' before applying any transformation algorithms, which might
      decompose certain Unicode code points to the separator characters
      (e.g., U+FE6B SMALL COMMERCIAL AT might decompose into U+0040
      COMMERCIAL AT).

<span class="h3"><a class="selflink" name="section-2.2" href="#section-2.2">2.2</a>.  Domainpart</span>

   The domainpart of a JID is that portion after the '@' character (if
   any) and before the '/' character (if any); it is the primary
   identifier and is the only REQUIRED element of a JID (a mere
   domainpart is a valid JID).  Typically a domainpart identifies the
   "home" server to which clients connect for XML routing and data
   management functionality.  However, it is not necessary for an XMPP
   domainpart to identify an entity that provides core XMPP server
   functionality (e.g., a domainpart can identify an entity such as a
   multi-user chat service, a publish-subscribe service, or a user
   directory).

   The domainpart for every XMPP service MUST be a fully qualified
   domain name (FQDN; see [<a href="#ref-DNS" title="&quot;Domain names - implementation and specification&quot;">DNS</a>]), IPv4 address, IPv6 address, or
   unqualified hostname (i.e., a text label that is resolvable on a
   local network).

      Interoperability Note: Domainparts that are IP addresses might not
      be accepted by other services for the sake of server-to-server
      communication, and domainparts that are unqualified hostnames
      cannot be used on public networks because they are resolvable only
      on a local network.

   If the domainpart includes a final character considered to be a label
   separator (dot) by [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>] or [<a href="#ref-DNS" title="&quot;Domain names - implementation and specification&quot;">DNS</a>], this character MUST be
   stripped from the domainpart before the JID of which it is a part is
   used for the purpose of routing an XML stanza, comparing against
   another JID, or constructing an [<a href="#ref-XMPP-URI" title="&quot;Internationalized Resource Identifiers (IRIs) and Uniform Resource Identifiers (URIs) for the Extensible Messaging and Presence Protocol (XMPP)&quot;">XMPP-URI</a>].  In particular, the
   character MUST be stripped before any other canonicalization steps
   are taken, such as application of the [<a href="#ref-NAMEPREP" title="&quot;Nameprep: A Stringprep Profile for Internationalized Domain Names (IDN)&quot;">NAMEPREP</a>] profile of
   [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>] or completion of the ToASCII operation as described in
   [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>].

   A domainpart consisting of a fully qualified domain name MUST be an
   "internationalized domain name" as defined in [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>]; that is, it
   MUST be "a domain name in which every label is an internationalized
   label" and MUST follow the rules for construction of



<span class="grey">Saint-Andre                  Standards Track                    [Page 6]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-7" id="page-7" href="#page-7" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   internationalized domain names specified in [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>].  When
   preparing a text label (consisting of a sequence of UTF-8 encoded
   Unicode code points) for representation as an internationalized label
   in the process of constructing an XMPP domainpart or comparing two
   XMPP domainparts, an application MUST ensure that for each text label
   it is possible to apply without failing the ToASCII operation
   specified in [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>] with the UseSTD3ASCIIRules flag set (thus
   forbidding ASCII code points other than letters, digits, and
   hyphens).  If the ToASCII operation can be applied without failing,
   then the label is an internationalized label.  (Note: The ToASCII
   operation includes application of the [<a href="#ref-NAMEPREP" title="&quot;Nameprep: A Stringprep Profile for Internationalized Domain Names (IDN)&quot;">NAMEPREP</a>] profile of
   [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>] and encoding using the algorithm specified in
   [<a href="#ref-PUNYCODE" title="&quot;Punycode: A Bootstring encoding of Unicode for Internationalized Domain Names in Applications (IDNA)&quot;">PUNYCODE</a>]; for details, see [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>].)  Although XMPP applications
   do not communicate the output of the ToASCII operation (called an
   "ACE label") over the wire, it MUST be possible to apply that
   operation without failing to each internationalized label.  If an
   XMPP application receives as input an ACE label, it SHOULD convert
   that ACE label to an internationalized label using the ToUnicode
   operation (see [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>]) before including the label in an XMPP
   domainpart that will be communicated over the wire on an XMPP network
   (however, instead of converting the label, there are legitimate
   reasons why an application might instead refuse the input altogether
   and return an error to the entity that provided the offending data).

   A domainpart MUST NOT be zero bytes in length and MUST NOT be more
   than 1023 bytes in length.  This rule is to be enforced after any
   mapping or normalization resulting from application of the Nameprep
   profile of stringprep (e.g., in Nameprep some characters can be
   mapped to nothing, which might result in a string of zero length).
   Naturally, the length limits of [<a href="#ref-DNS" title="&quot;Domain names - implementation and specification&quot;">DNS</a>] apply, and nothing in this
   document is to be interpreted as overriding those more fundamental
   limits.

   In the terms of IDNA2008 [<a href="#ref-IDNA-DEFS" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">IDNA-DEFS</a>], the domainpart of a JID is a
   "domain name slot".

<span class="h3"><a class="selflink" name="section-2.3" href="#section-2.3">2.3</a>.  Localpart</span>

   The localpart of a JID is an optional identifier placed before the
   domainpart and separated from the latter by the '@' character.
   Typically a localpart uniquely identifies the entity requesting and
   using network access provided by a server (i.e., a local account),
   although it can also represent other kinds of entities (e.g., a chat
   room associated with a multi-user chat service).  The entity
   represented by an XMPP localpart is addressed within the context of a
   specific domain (i.e., &lt;localpart@domainpart&gt;).





<span class="grey">Saint-Andre                  Standards Track                    [Page 7]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-8" id="page-8" href="#page-8" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   A localpart MUST be formatted such that the Nodeprep profile of
   [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>] can be applied without failing (see <a href="#appendix-A">Appendix A</a>).  Before
   comparing two localparts, an application MUST first ensure that the
   Nodeprep profile has been applied to each identifier (the profile
   need not be applied each time a comparison is made, as long as it has
   been applied before comparison).

   A localpart MUST NOT be zero bytes in length and MUST NOT be more
   than 1023 bytes in length.  This rule is to be enforced after any
   mapping or normalization resulting from application of the Nodeprep
   profile of stringprep (e.g., in Nodeprep some characters can be
   mapped to nothing, which might result in a string of zero length).

<span class="h3"><a class="selflink" name="section-2.4" href="#section-2.4">2.4</a>.  Resourcepart</span>

   The resourcepart of a JID is an optional identifier placed after the
   domainpart and separated from the latter by the '/' character.  A
   resourcepart can modify either a &lt;localpart@domainpart&gt; address or a
   mere &lt;domainpart&gt; address.  Typically a resourcepart uniquely
   identifies a specific connection (e.g., a device or location) or
   object (e.g., an occupant in a multi-user chat room) belonging to the
   entity associated with an XMPP localpart at a domain (i.e.,
   &lt;localpart@domainpart/resourcepart&gt;).

   A resourcepart MUST be formatted such that the Resourceprep profile
   of [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>] can be applied without failing (see <a href="#appendix-B">Appendix B</a>).
   Before comparing two resourceparts, an application MUST first ensure
   that the Resourceprep profile has been applied to each identifier
   (the profile need not be applied each time a comparison is made, as
   long as it has been applied before comparison).

   A resourcepart MUST NOT be zero bytes in length and MUST NOT be more
   than 1023 bytes in length.  This rule is to be enforced after any
   mapping or normalization resulting from application of the
   Resourceprep profile of stringprep (e.g., in Resourceprep some
   characters can be mapped to nothing, which might result in a string
   of zero length).

      Informational Note: For historical reasons, the term "resource
      identifier" is often used in XMPP to refer to the optional portion
      of an XMPP address that follows the domainpart and the "/"
      separator character; to help prevent confusion between an XMPP
      "resource identifier" and the meanings of "resource" and
      "identifier" provided in Section 1.1 of [<a href="#ref-URI" title="&quot;Uniform Resource Identifier (URI): Generic Syntax&quot;">URI</a>], this specification
      uses the term "resourcepart" instead of "resource identifier" (as
      in <a href="./rfc3920">RFC 3920</a>).





<span class="grey">Saint-Andre                  Standards Track                    [Page 8]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-9" id="page-9" href="#page-9" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   XMPP entities SHOULD consider resourceparts to be opaque strings and
   SHOULD NOT impute meaning to any given resourcepart.  In particular:

   o  Use of the '/' character as a separator between the domainpart and
      the resourcepart does not imply that XMPP addresses are
      hierarchical in the way that, say, HTTP addresses are
      hierarchical; thus for example an XMPP address of the form
      &lt;localpart@domainpart/foo/bar&gt; does not identify a resource "bar"
      that exists below a resource "foo" in a hierarchy of resources
      associated with the entity "localpart@domain".

   o  The '@' character is allowed in the resourcepart and is often used
      in the "nick" shown in XMPP chatrooms.  For example, the JID
      &lt;room@chat.example.com/user@host&gt; describes an entity who is an
      occupant of the room &lt;room@chat.example.com&gt; with an (asserted)
      nick of &lt;user@host&gt;.  However, chatroom services do not
      necessarily check such an asserted nick against the occupant's
      real JID.

<span class="h2"><a class="selflink" name="section-3" href="#section-3">3</a>.  Internationalization Considerations</span>

   XMPP servers MUST, and XMPP clients SHOULD, support [<a href="#ref-IDNA2003" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">IDNA2003</a>] for
   domainparts (including the [<a href="#ref-NAMEPREP" title="&quot;Nameprep: A Stringprep Profile for Internationalized Domain Names (IDN)&quot;">NAMEPREP</a>] profile of [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>]), the
   Nodeprep (Appendix A) profile of [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>] for localparts, and the
   Resourceprep (Appendix B) profile of [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>] for resourceparts;
   this enables XMPP addresses to include a wide variety of characters
   outside the US-ASCII range.  Rules for enforcement of the XMPP
   address format are provided in [<a href="#ref-XMPP" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">XMPP</a>].

<span class="h2"><a class="selflink" name="section-4" href="#section-4">4</a>.  Security Considerations</span>

<span class="h3"><a class="selflink" name="section-4.1" href="#section-4.1">4.1</a>.  Reuse of Stringprep</span>

   The security considerations described in [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>] apply to the
   Nodeprep (Appendix A) and Resourceprep (Appendix B) profiles defined
   in this document for XMPP localparts and resourceparts.  The security
   considerations described in [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>] and [<a href="#ref-NAMEPREP" title="&quot;Nameprep: A Stringprep Profile for Internationalized Domain Names (IDN)&quot;">NAMEPREP</a>] apply to the
   Nameprep profile that is reused here for XMPP domainparts.

<span class="h3"><a class="selflink" name="section-4.2" href="#section-4.2">4.2</a>.  Reuse of Unicode</span>

   The security considerations described in [<a href="#ref-UNICODE-SEC" title="&quot;Unicode Technical Report #36: Unicode Security Considerations&quot;">UNICODE-SEC</a>] apply to the
   use of Unicode characters in XMPP addresses.

<span class="h3"><a class="selflink" name="section-4.3" href="#section-4.3">4.3</a>.  Address Spoofing</span>

   There are two forms of address spoofing: forging and mimicking.




<span class="grey">Saint-Andre                  Standards Track                    [Page 9]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-10" id="page-10" href="#page-10" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


<span class="h4"><a class="selflink" name="section-4.3.1" href="#section-4.3.1">4.3.1</a>.  Address Forging</span>

   In the context of XMPP technologies, address forging occurs when an
   entity is able to generate an XML stanza whose 'from' address does
   not correspond to the account credentials with which the entity
   authenticated onto the network (or an authorization identity provided
   during negotiation of SASL authentication [<a href="#ref-SASL" title="&quot;Simple Authentication and Security Layer (SASL)&quot;">SASL</a>] as described in
   [<a href="#ref-XMPP" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">XMPP</a>]).  For example, address forging occurs if an entity that
   authenticated as "juliet@im.example.com" is able to send XML stanzas
   from "nurse@im.example.com" or "romeo@example.net".

   Address forging is difficult in XMPP systems, given the requirement
   for sending servers to stamp 'from' addresses and for receiving
   servers to verify sending domains via server-to-server authentication
   (see [<a href="#ref-XMPP" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">XMPP</a>]).  However, address forging is possible if:

   o  A poorly implemented server ignores the requirement for stamping
      the 'from' address.  This would enable any entity that
      authenticated with the server to send stanzas from any
      localpart@domainpart as long as the domainpart matches the sending
      domain of the server.

   o  An actively malicious server generates stanzas on behalf of any
      registered account.

   Therefore, an entity outside the security perimeter of a particular
   server cannot reliably distinguish between JIDs of the form
   &lt;localpart@domainpart&gt; at that server and thus can authenticate only
   the domainpart of such JIDs with any level of assurance.  This
   specification does not define methods for discovering or
   counteracting such poorly implemented or rogue servers.  However, the
   end-to-end authentication or signing of XMPP stanzas could help to
   mitigate this risk, since it would require the rogue server to
   generate false credentials in addition to modifying 'from' addresses.

   Furthermore, it is possible for an attacker to forge JIDs at other
   domains by means of a DNS poisoning attack if DNS security extensions
   [<a href="#ref-DNSSEC" title="&quot;DNS Security Introduction and Requirements&quot;">DNSSEC</a>] are not used.

<span class="h4"><a class="selflink" name="section-4.3.2" href="#section-4.3.2">4.3.2</a>.  Address Mimicking</span>

   Address mimicking occurs when an entity provides legitimate
   authentication credentials for and sends XML stanzas from an account
   whose JID appears to a human user to be the same as another JID.  For
   example, in some XMPP clients the address "ju1iet@example.org"
   (spelled with the number one as the third character of the localpart)
   might appear to be the same as "juliet@example.org (spelled with the
   lower-case version of the letter "L"), especially on casual visual



<span class="grey">Saint-Andre                  Standards Track                   [Page 10]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-11" id="page-11" href="#page-11" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   inspection; this phenomenon is sometimes called "typejacking".  A
   more sophisticated example of address mimicking might involve the use
   of characters from outside the familiar Latin extended-A block of
   Unicode code points, such as the characters U+13DA U+13A2 U+13B5
   U+13AC U+13A2 U+13AC U+13D2 from the Cherokee block instead of the
   similar-looking US-ASCII characters "STPETER".

   In some examples of address mimicking, it is unlikely that the
   average user could tell the difference between the real JID and the
   fake JID.  (Indeed, there is no programmatic way to distinguish with
   full certainty which is the fake JID and which is the real JID; in
   some communication contexts, the JID formed of Cherokee characters
   might be the real JID and the JID formed of US-ASCII characters might
   thus appear to be the fake JID.)  Because JIDs can contain almost any
   properly encoded Unicode code point, it can be relatively easy to
   mimic some JIDs in XMPP systems.  The possibility of address
   mimicking introduces security vulnerabilities of the kind that have
   also plagued the World Wide Web, specifically the phenomenon known as
   phishing.

   These problems arise because Unicode and ISO/IEC 10646 repertoires
   have many characters that look similar (so-called "confusable
   characters" or "confusables").  In many cases, XMPP users might
   perform visual matching, such as when comparing the JIDs of
   communication partners.  Because it is impossible to map similar-
   looking characters without a great deal of context (such as knowing
   the fonts used), stringprep and stringprep-based technologies such as
   Nameprep, Nodeprep, and Resourceprep do nothing to map similar-
   looking characters together, nor do they prohibit some characters
   because they look like others.  As a result, XMPP localparts and
   resourceparts could contain confusable characters, producing JIDs
   that appear to mimic other JIDs and thus leading to security
   vulnerabilities such as the following:

   o  A localpart can be employed as one part of an entity's address in
      XMPP.  One common usage is as the username of an instant messaging
      user; another is as the name of a multi-user chat room; and many
      other kinds of entities could use localparts as part of their
      addresses.  The security of such services could be compromised
      based on different interpretations of the internationalized
      localpart; for example, a user entering a single internationalized
      localpart could access another user's account information, or a
      user could gain access to a hidden or otherwise restricted chat
      room or service.

   o  A resourcepart can be employed as one part of an entity's address
      in XMPP.  One common usage is as the name for an instant messaging
      user's connected resource; another is as the nickname of a user in



<span class="grey">Saint-Andre                  Standards Track                   [Page 11]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-12" id="page-12" href="#page-12" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


      a multi-user chat room; and many other kinds of entities could use
      resourceparts as part of their addresses.  The security of such
      services could be compromised based on different interpretations
      of the internationalized resourcepart; for example, two or more
      confusable resources could be bound at the same time to the same
      account (resulting in inconsistent authorization decisions in an
      XMPP application that uses full JIDs), or a user could send a
      message to someone other than the intended recipient in a multi-
      user chat room.

   Despite the fact that some specific suggestions about identification
   and handling of confusable characters appear in the Unicode Security
   Considerations [<a href="#ref-UNICODE-SEC" title="&quot;Unicode Technical Report #36: Unicode Security Considerations&quot;">UNICODE-SEC</a>], it is also true (as noted in
   [<a href="#ref-IDNA-DEFS" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">IDNA-DEFS</a>]) that "there are no comprehensive technical solutions to
   the problems of confusable characters".  Mimicked JIDs that involve
   characters from only one script, or from the script typically
   employed by a particular user or community of language users, are not
   easy to combat (e.g., the simple typejacking attack previously
   described, which relies on a surface similarity between the
   characters "1" and "l" in some presentations).  However, mimicked
   addresses that involve characters from more than one script, or from
   a script not typically employed by a particular user or community of
   language users, can be mitigated somewhat through the application of
   appropriate registration policies at XMPP services and presentation
   policies in XMPP client software.  Therefore, the following policies
   are encouraged:

   1.  Because an XMPP service that allows registration of XMPP user
       accounts (localparts) plays a role similar to that of a registry
       for DNS domain names, such a service SHOULD establish a policy
       about the scripts or blocks of characters it will allow in
       localparts at the service.  Such a policy is likely to be
       informed by the languages and scripts that are used to write
       registered account names; in particular, to reduce confusion, the
       service MAY forbid registration of XMPP localparts that contain
       characters from more than one script and to restrict
       registrations to characters drawn from a very small number of
       scripts (e.g., scripts that are well-understood by the
       administrators of the service).  Such policies are also
       appropriate for XMPP services that allow temporary or permanent
       registration of XMPP resourceparts, e.g., during resource binding
       [<a href="#ref-XMPP" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">XMPP</a>] or upon joining an XMPP-based chat room [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>].  For
       related considerations in the context of domain name
       registration, refer to Section 4.3 of [<a href="#ref-IDNA-PROTO" title="&quot;Internationalized Domain Names in Applications (IDNA): Protocol&quot;">IDNA-PROTO</a>] and <a href="#section-3.2">Section</a>
       <a href="#section-3.2">3.2</a> of [<a href="#ref-IDNA-RATIONALE" title="&quot;Internationalized Domain Names for Applications (IDNA): Background, Explanation, and Rationale&quot;">IDNA-RATIONALE</a>].  Note well that methods for enforcing
       such restrictions are out of scope for this document.





<span class="grey">Saint-Andre                  Standards Track                   [Page 12]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-13" id="page-13" href="#page-13" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   2.  Because every human user of an XMPP client presumably has a
       preferred language (or, in some cases, a small set of preferred
       languages), an XMPP client SHOULD gather that information either
       explicitly from the user or implicitly via the operating system
       of the user's device.  Furthermore, because most languages are
       typically represented by a single script (or a small set of
       scripts) and most scripts are typically contained in one or more
       blocks of characters, an XMPP client SHOULD warn the user when
       presenting a JID that mixes characters from more than one script
       or block, or that uses characters outside the normal range of the
       user's preferred language(s).  This recommendation is not
       intended to discourage communication across different communities
       of language users; instead, it recognizes the existence of such
       communities and encourages due caution when presenting unfamiliar
       scripts or characters to human users.

<span class="h2"><a class="selflink" name="section-5" href="#section-5">5</a>.  IANA Considerations</span>

   The following sections update the registrations provided in
   [<a href="./rfc3920" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC3920</a>].

<span class="h3"><a class="selflink" name="section-5.1" href="#section-5.1">5.1</a>.  Nodeprep Profile of Stringprep</span>

   The Nodeprep profile of stringprep is defined under Nodeprep
   (Appendix A).  The IANA has registered Nodeprep in the "Stringprep
   Profiles" registry.

   Name of this profile:

      Nodeprep

   RFC in which the profile is defined:

      <a href="./rfc6122">RFC 6122</a>

   Indicator whether or not this is the newest version of the profile:

      This is the first version of Nodeprep













<span class="grey">Saint-Andre                  Standards Track                   [Page 13]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-14" id="page-14" href="#page-14" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


<span class="h3"><a class="selflink" name="section-5.2" href="#section-5.2">5.2</a>.  Resourceprep Profile of Stringprep</span>

   The Resourceprep profile of stringprep is defined under Resourceprep
   (Appendix B).  The IANA has registered Resourceprep in the
   "Stringprep Profiles" registry.

   Name of this profile:

      Resourceprep

   RFC in which the profile is defined:

      <a href="./rfc6122">RFC 6122</a>

   Indicator whether or not this is the newest version of the profile:

      This is the first version of Resourceprep

<span class="h2"><a class="selflink" name="section-6" href="#section-6">6</a>.  Conformance Requirements</span>

   This section describes a protocol feature set that summarizes the
   conformance requirements of this specification.  This feature set is
   appropriate for use in software certification, interoperability
   testing, and implementation reports.  For each feature, this section
   provides the following information:

   o  A human-readable name

   o  An informational description

   o  A reference to the particular section of this document that
      normatively defines the feature

   o  Whether the feature applies to the Client role, the Server role,
      or both (where "N/A" signifies that the feature is not applicable
      to the specified role)

   o  Whether the feature MUST or SHOULD be implemented, where the
      capitalized terms are to be understood as described in [<a href="#ref-KEYWORDS" title="&quot;Key words for use in RFCs to Indicate Requirement Levels&quot;">KEYWORDS</a>]

   The feature set specified here attempts to adhere to the concepts and
   formats proposed by Larry Masinter within the IETF's NEWTRK Working
   Group in 2005, as captured in [<a href="#ref-INTEROP" title="&quot;Formalizing IETF Interoperability Reporting&quot;">INTEROP</a>].  Although this feature set
   is more detailed than called for by [<a href="#ref-REPORTS" title="&quot;Guidance on Interoperation and Implementation Reports for Advancement to Draft Standard&quot;">REPORTS</a>], it provides a suitable
   basis for the generation of implementation reports to be submitted in
   support of advancing this specification from Proposed Standard to
   Draft Standard in accordance with [<a href="#ref-PROCESS" title="&quot;The Internet Standards Process -- Revision 3&quot;">PROCESS</a>].




<span class="grey">Saint-Andre                  Standards Track                   [Page 14]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-15" id="page-15" href="#page-15" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   Feature:  address-domain-length
   Description:  Ensure that the domainpart of an XMPP address is at
      least one byte in length and at most 1023 bytes in length, and
      conforms to the underlying length limits of the DNS.
   Section:  <a href="#section-2.2">Section 2.2</a>
   Roles:  Both MUST.

   Feature:  address-domain-prep
   Description:  Ensure that the domainpart of an XMPP address conforms
      to the Nameprep profile of stringprep.
   Section:  <a href="#section-2.2">Section 2.2</a>
   Roles:  Client SHOULD, Server MUST.

   Feature:  address-localpart-length
   Description:  Ensure that the localpart of an XMPP address is at
      least one byte in length and at most 1023 bytes in length.
   Section:  <a href="#section-2.3">Section 2.3</a>
   Roles:  Both MUST.

   Feature:  address-localpart-prep
   Description:  Ensure that the localpart of an XMPP address conforms
      to the Nodeprep profile of stringprep.
   Section:  <a href="#section-2.3">Section 2.3</a>
   Roles:  Client SHOULD, Server MUST.

   Feature:  address-resource-length
   Description:  Ensure that the resourcepart of an XMPP address is at
      least one byte in length and at most 1023 bytes in length.
   Section:  <a href="#section-2.4">Section 2.4</a>
   Roles:  Both MUST.

   Feature:  address-resource-prep
   Description:  Ensure that the resourcepart of an XMPP address
      conforms to the Resourceprep profile of stringprep.
   Section:  <a href="#section-2.4">Section 2.4</a>
   Roles:  Client SHOULD, Server MUST.















<span class="grey">Saint-Andre                  Standards Track                   [Page 15]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-16" id="page-16" href="#page-16" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


<span class="h2"><a class="selflink" name="section-7" href="#section-7">7</a>.  References</span>

<span class="h3"><a class="selflink" name="section-7.1" href="#section-7.1">7.1</a>.  Normative References</span>

   [<a name="ref-ABNF" id="ref-ABNF">ABNF</a>]            Crocker, D., Ed. and P. Overell, "Augmented BNF for
                     Syntax Specifications: ABNF", STD 68, <a href="./rfc5234">RFC 5234</a>,
                     January 2008.

   [<a name="ref-DNS" id="ref-DNS">DNS</a>]             Mockapetris, P., "Domain names - implementation and
                     specification", STD 13, <a href="./rfc1035">RFC 1035</a>, November 1987.

   [<a name="ref-IDNA2003" id="ref-IDNA2003">IDNA2003</a>]        Faltstrom, P., Hoffman, P., and A. Costello,
                     "Internationalizing Domain Names in Applications
                     (IDNA)", <a href="./rfc3490">RFC 3490</a>, March 2003.

                     See <a href="#section-1">Section 1</a> for an explanation of why the
                     normative reference to an obsoleted specification
                     is needed.

   [<a name="ref-KEYWORDS" id="ref-KEYWORDS">KEYWORDS</a>]        Bradner, S., "Key words for use in RFCs to Indicate
                     Requirement Levels", <a href="./bcp14">BCP 14</a>, <a href="./rfc2119">RFC 2119</a>, March 1997.

   [<a name="ref-NAMEPREP" id="ref-NAMEPREP">NAMEPREP</a>]        Hoffman, P. and M. Blanchet, "Nameprep: A
                     Stringprep Profile for Internationalized Domain
                     Names (IDN)", <a href="./rfc3491">RFC 3491</a>, March 2003.

                     See <a href="#section-1">Section 1</a> for an explanation of why the
                     normative reference to an obsoleted specification
                     is needed.

   [<a name="ref-STRINGPREP" id="ref-STRINGPREP">STRINGPREP</a>]      Hoffman, P. and M. Blanchet, "Preparation of
                     Internationalized Strings ("stringprep")",
                     <a href="./rfc3454">RFC 3454</a>, December 2002.

   [<a name="ref-UNICODE" id="ref-UNICODE">UNICODE</a>]         The Unicode Consortium, "The Unicode Standard,
                     Version 3.2.0", 2000.  The Unicode Standard,
                     Version 3.2.0 is defined by The Unicode Standard,
                     Version 3.0 (Reading, MA, Addison-Wesley, 2000.
                     ISBN 0-201-61633-5), as amended by the Unicode
                     Standard Annex #27: Unicode 3.1
                     (<a href="http://www.unicode.org/reports/tr27/">http://www.unicode.org/reports/tr27/</a>) and by the
                     Unicode Standard Annex #28: Unicode 3.2
                     (<a href="http://www.unicode.org/reports/tr28/">http://www.unicode.org/reports/tr28/</a>).

   [<a name="ref-UNICODE-SEC" id="ref-UNICODE-SEC">UNICODE-SEC</a>]     The Unicode Consortium, "Unicode Technical Report
                     #36: Unicode Security Considerations", 2008,
                     &lt;<a href="http://www.unicode.org/reports/tr36/">http://www.unicode.org/reports/tr36/</a>&gt;.




<span class="grey">Saint-Andre                  Standards Track                   [Page 16]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-17" id="page-17" href="#page-17" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   [<a name="ref-UTF-8" id="ref-UTF-8">UTF-8</a>]           Yergeau, F., "UTF-8, a transformation format of ISO
                     10646", STD 63, <a href="./rfc3629">RFC 3629</a>, November 2003.

   [<a name="ref-XMPP" id="ref-XMPP">XMPP</a>]            Saint-Andre, P., "Extensible Messaging and Presence
                     Protocol (XMPP): Core", <a href="./rfc6120">RFC 6120</a>, March 2011.

<span class="h3"><a class="selflink" name="section-7.2" href="#section-7.2">7.2</a>.  Informative References</span>

   [<a name="ref-DNSSEC" id="ref-DNSSEC">DNSSEC</a>]          Arends, R., Austein, R., Larson, M., Massey, D.,
                     and S. Rose, "DNS Security Introduction and
                     Requirements", <a href="./rfc4033">RFC 4033</a>, March 2005.

   [<a name="ref-IDNA-DEFS" id="ref-IDNA-DEFS">IDNA-DEFS</a>]       Klensin, J., "Internationalized Domain Names for
                     Applications (IDNA): Definitions and Document
                     Framework", <a href="./rfc5890">RFC 5890</a>, August 2010.

   [<a name="ref-IDNA-PROTO" id="ref-IDNA-PROTO">IDNA-PROTO</a>]      Klensin, J., "Internationalized Domain Names in
                     Applications (IDNA): Protocol", <a href="./rfc5891">RFC 5891</a>,
                     August 2010.

   [<a name="ref-IDNA-RATIONALE" id="ref-IDNA-RATIONALE">IDNA-RATIONALE</a>]  Klensin, J., "Internationalized Domain Names for
                     Applications (IDNA): Background, Explanation, and
                     Rationale", <a href="./rfc5894">RFC 5894</a>, August 2010.

   [<a name="ref-INTEROP" id="ref-INTEROP">INTEROP</a>]         Masinter, L., "Formalizing IETF Interoperability
                     Reporting", Work in Progress, October 2005.

   [<a name="ref-IRI" id="ref-IRI">IRI</a>]             Duerst, M. and M. Suignard, "Internationalized
                     Resource Identifiers (IRIs)", <a href="./rfc3987">RFC 3987</a>,
                     January 2005.

   [<a name="ref-PROCESS" id="ref-PROCESS">PROCESS</a>]         Bradner, S., "The Internet Standards Process --
                     Revision 3", <a href="./bcp9">BCP 9</a>, <a href="./rfc2026">RFC 2026</a>, October 1996.

   [<a name="ref-PUNYCODE" id="ref-PUNYCODE">PUNYCODE</a>]        Costello, A., "Punycode: A Bootstring encoding of
                     Unicode for Internationalized Domain Names in
                     Applications (IDNA)", <a href="./rfc3492">RFC 3492</a>, March 2003.

   [<a name="ref-REPORTS" id="ref-REPORTS">REPORTS</a>]         Dusseault, L. and R. Sparks, "Guidance on
                     Interoperation and Implementation Reports for
                     Advancement to Draft Standard", <a href="./bcp9">BCP 9</a>, <a href="./rfc5657">RFC 5657</a>,
                     September 2009.

   [<a name="ref-RFC3920" id="ref-RFC3920">RFC3920</a>]         Saint-Andre, P., Ed., "Extensible Messaging and
                     Presence Protocol (XMPP): Core", <a href="./rfc3920">RFC 3920</a>,
                     October 2004.





<span class="grey">Saint-Andre                  Standards Track                   [Page 17]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-18" id="page-18" href="#page-18" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   [<a name="ref-RFC5952" id="ref-RFC5952">RFC5952</a>]         Kawamura, S. and M. Kawashima, "A Recommendation
                     for IPv6 Address Text Representation", <a href="./rfc5952">RFC 5952</a>,
                     August 2010.

   [<a name="ref-SASL" id="ref-SASL">SASL</a>]            Melnikov, A., Ed. and K. Zeilenga, Ed., "Simple
                     Authentication and Security Layer (SASL)",
                     <a href="./rfc4422">RFC 4422</a>, June 2006.

   [<a name="ref-URI" id="ref-URI">URI</a>]             Berners-Lee, T., Fielding, R., and L. Masinter,
                     "Uniform Resource Identifier (URI): Generic
                     Syntax", STD 66, <a href="./rfc3986">RFC 3986</a>, January 2005.

   [<a name="ref-XEP-0029" id="ref-XEP-0029">XEP-0029</a>]        Kaes, C., "Definition of Jabber Identifiers
                     (JIDs)", XSF XEP 0029, October 2003.

   [<a name="ref-XEP-0030" id="ref-XEP-0030">XEP-0030</a>]        Hildebrand, J., Millard, P., Eatmon, R., and P.
                     Saint-Andre, "Service Discovery", XSF XEP 0030,
                     June 2008.

   [<a name="ref-XEP-0045" id="ref-XEP-0045">XEP-0045</a>]        Saint-Andre, P., "Multi-User Chat", XSF XEP 0045,
                     July 2008.

   [<a name="ref-XEP-0060" id="ref-XEP-0060">XEP-0060</a>]        Millard, P., Saint-Andre, P., and R. Meijer,
                     "Publish-Subscribe", XSF XEP 0060, July 2010.

   [<a name="ref-XEP-0165" id="ref-XEP-0165">XEP-0165</a>]        Saint-Andre, P., "Best Practices to Discourage JID
                     Mimicking", XSF XEP 0045, December 2007.

   [<a name="ref-XML" id="ref-XML">XML</a>]             Paoli, J., Maler, E., Sperberg-McQueen, C.,
                     Yergeau, F., and T. Bray, "Extensible Markup
                     Language (XML) 1.0 (Fourth Edition)", World Wide
                     Web Consortium Recommendation REC-xml-20060816,
                     August 2006,
                     &lt;<a href="http://www.w3.org/TR/2006/REC-xml-20060816">http://www.w3.org/TR/2006/REC-xml-20060816</a>&gt;.

   [<a name="ref-XMPP-URI" id="ref-XMPP-URI">XMPP-URI</a>]        Saint-Andre, P., "Internationalized Resource
                     Identifiers (IRIs) and Uniform Resource Identifiers
                     (URIs) for the Extensible Messaging and Presence
                     Protocol (XMPP)", <a href="./rfc5122">RFC 5122</a>, February 2008.












<span class="grey">Saint-Andre                  Standards Track                   [Page 18]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-19" id="page-19" href="#page-19" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


<span class="h2"><a class="selflink" name="appendix-A" href="#appendix-A">Appendix A</a>.  Nodeprep</span>

<span class="h3"><a class="selflink" name="appendix-A.1" href="#appendix-A.1">A.1</a>.  Introduction</span>

   This appendix defines the "Nodeprep" profile of stringprep.  As such,
   it specifies processing rules that will enable users to enter
   internationalized localparts in the Extensible Messaging and Presence
   Protocol (XMPP) and have the highest chance of getting the content of
   the strings correct.  (An XMPP localpart is the optional portion of
   an XMPP address that precedes an XMPP domainpart and the '@'
   separator; it is often but not exclusively associated with an instant
   messaging username.)  These processing rules are intended only for
   XMPP localparts and are not intended for arbitrary text or any other
   aspect of an XMPP address.

   This profile defines the following, as required by [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>]:

   o  The intended applicability of the profile: internationalized
      localparts within XMPP

   o  The character repertoire that is the input and output to
      stringprep: Unicode 3.2, specified in A.2

   o  The mappings used: specified in A.3

   o  The Unicode normalization used: specified in A.4

   o  The characters that are prohibited as output: specified in A.5

   o  Bidirectional character handling: specified in A.6

<span class="h3"><a class="selflink" name="appendix-A.2" href="#appendix-A.2">A.2</a>.  Character Repertoire</span>

   This profile uses Unicode 3.2 with the list of unassigned code points
   in Table A.1, both as defined in <a href="#appendix-A">Appendix A</a> of [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>].

<span class="h3"><a class="selflink" name="appendix-A.3" href="#appendix-A.3">A.3</a>.  Mapping</span>

   This profile specifies mapping using the following tables from
   [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>]:

      Table B.1
      Table B.2

<span class="h3"><a class="selflink" name="appendix-A.4" href="#appendix-A.4">A.4</a>.  Normalization</span>

   This profile specifies the use of Unicode Normalization Form KC, as
   described in [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>].



<span class="grey">Saint-Andre                  Standards Track                   [Page 19]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-20" id="page-20" href="#page-20" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


<span class="h3"><a class="selflink" name="appendix-A.5" href="#appendix-A.5">A.5</a>.  Prohibited Output</span>

   This profile specifies the prohibition of using the following tables
   from [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>].

      Table C.1.1
      Table C.1.2
      Table C.2.1
      Table C.2.2
      Table C.3
      Table C.4
      Table C.5
      Table C.6
      Table C.7
      Table C.8
      Table C.9

   In addition, the following additional Unicode characters are also
   prohibited:

      U+0022 (QUOTATION MARK), i.e., "
      U+0026 (AMPERSAND), i.e., &amp;
      U+0027 (APOSTROPHE), i.e., '
      U+002F (SOLIDUS), i.e., /
      U+003A (COLON), i.e., :
      U+003C (LESS-THAN SIGN), i.e., &lt;
      U+003E (GREATER-THAN SIGN), i.e., &gt;
      U+0040 (COMMERCIAL AT), i.e., @

<span class="h3"><a class="selflink" name="appendix-A.6" href="#appendix-A.6">A.6</a>.  Bidirectional Characters</span>

   This profile specifies checking bidirectional strings, as described
   in Section 6 of [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>].

<span class="h3"><a class="selflink" name="appendix-A.7" href="#appendix-A.7">A.7</a>.  Notes</span>

   Because the additional characters prohibited by Nodeprep are
   prohibited after normalization, an implementation MUST NOT enable a
   human user to input any Unicode code point whose decomposition
   includes those characters; such code points include but are not
   necessarily limited to the following (refer to [<a href="#ref-UNICODE" title="&quot;The Unicode Standard, Version 3.2.0&quot;">UNICODE</a>] for complete
   information):









<span class="grey">Saint-Andre                  Standards Track                   [Page 20]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-21" id="page-21" href="#page-21" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   o  U+2100 (ACCOUNT OF)
   o  U+2101 (ADDRESSED TO THE SUBJECT)
   o  U+2105 (CARE OF)
   o  U+2106 (CADA UNA)
   o  U+226E (NOT LESS-THAN)
   o  U+226F (NOT GREATER-THAN)
   o  U+2A74 (DOUBLE COLON EQUAL)
   o  U+FE13 (PRESENTATION FORM FOR VERTICAL COLON)
   o  U+FE60 (SMALL AMPERSAND)
   o  U+FE64 (SMALL LESS-THAN SIGN)
   o  U+FE65 (SMALL GREATER-THAN SIGN)
   o  U+FE6B (SMALL COMMERCIAL AT)
   o  U+FF02 (FULLWIDTH QUOTATION MARK)
   o  U+FF06 (FULLWIDTH AMPERSAND)
   o  U+FF07 (FULLWIDTH APOSTROPHE)
   o  U+FF0F (FULLWIDTH SOLIDUS)
   o  U+FF1A (FULLWIDTH COLON)
   o  U+FF1C (FULLWIDTH LESS-THAN SIGN)
   o  U+FF1E (FULLWIDTH GREATER-THAN SIGN)
   o  U+FF20 (FULLWIDTH COMMERCIAL AT)

<span class="h2"><a class="selflink" name="appendix-B" href="#appendix-B">Appendix B</a>.  Resourceprep</span>

<span class="h3"><a class="selflink" name="appendix-B.1" href="#appendix-B.1">B.1</a>.  Introduction</span>

   This appendix defines the "Resourceprep" profile of stringprep.  As
   such, it specifies processing rules that will enable users to enter
   internationalized resourceparts in the Extensible Messaging and
   Presence Protocol (XMPP) and have the highest chance of getting the
   content of the strings correct.  (An XMPP resourcepart is the
   optional portion of an XMPP address that follows an XMPP domainpart
   and the '/' separator.)  These processing rules are intended only for
   XMPP resourceparts and are not intended for arbitrary text or any
   other aspect of an XMPP address.

   This profile defines the following, as required by [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>]:

   o  The intended applicability of the profile: internationalized
      resourceparts within XMPP

   o  The character repertoire that is the input and output to
      stringprep: Unicode 3.2, specified in B.2

   o  The mappings used: specified in B.3

   o  The Unicode normalization used: specified in B.4

   o  The characters that are prohibited as output: specified in B.5



<span class="grey">Saint-Andre                  Standards Track                   [Page 21]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-22" id="page-22" href="#page-22" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   o  Bidirectional character handling: specified in B.6

<span class="h3"><a class="selflink" name="appendix-B.2" href="#appendix-B.2">B.2</a>.  Character Repertoire</span>

   This profile uses Unicode 3.2 with the list of unassigned code points
   in Table A.1, both as defined in <a href="#appendix-A">Appendix A</a> of [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>].

<span class="h3"><a class="selflink" name="appendix-B.3" href="#appendix-B.3">B.3</a>.  Mapping</span>

   This profile specifies mapping using the following tables from
   [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>]:

      Table B.1

<span class="h3"><a class="selflink" name="appendix-B.4" href="#appendix-B.4">B.4</a>.  Normalization</span>

   This profile specifies the use of Unicode Normalization Form KC, as
   described in [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>].

<span class="h3"><a class="selflink" name="appendix-B.5" href="#appendix-B.5">B.5</a>.  Prohibited Output</span>

   This profile specifies the prohibition of using the following tables
   from [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>].

      Table C.1.2
      Table C.2.1
      Table C.2.2
      Table C.3
      Table C.4
      Table C.5
      Table C.6
      Table C.7
      Table C.8
      Table C.9

<span class="h3"><a class="selflink" name="appendix-B.6" href="#appendix-B.6">B.6</a>.  Bidirectional Characters</span>

   This profile specifies checking bidirectional strings, as described
   in Section 6 of [<a href="#ref-STRINGPREP" title="&quot;Preparation of Internationalized Strings (&quot;">STRINGPREP</a>].

<span class="h2"><a class="selflink" name="appendix-C" href="#appendix-C">Appendix C</a>.  Differences from <a href="./rfc3920">RFC 3920</a></span>

   Based on consensus derived from implementation and deployment
   experience as well as formal interoperability testing, the following
   substantive modifications were made from <a href="./rfc3920">RFC 3920</a>.






<span class="grey">Saint-Andre                  Standards Track                   [Page 22]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-23" id="page-23" href="#page-23" class="invisible"> </a>
<span class="grey"><a href="./rfc6122">RFC 6122</a>                   XMPP Address Format                March 2011</span>


   o  Corrected the ABNF syntax to ensure consistency with [<a href="#ref-URI" title="&quot;Uniform Resource Identifier (URI): Generic Syntax&quot;">URI</a>] and
      [<a href="#ref-IRI" title="&quot;Internationalized Resource Identifiers (IRIs)&quot;">IRI</a>], including consistency with <a href="./rfc3986">RFC 3986</a> and [<a href="./rfc5952" title="&quot;A Recommendation for IPv6 Address Text Representation&quot;">RFC5952</a>] with
      regard to IPv6 addresses (e.g., enclosing the IPv6 address in
      square brackets '[' and ']' -- see also Section 4.9.3.19 of
      [<a href="#ref-XMPP" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">XMPP</a>]).

   o  Corrected the ABNF syntax to prevent zero-length localparts,
      domainparts, and resourceparts (and also noted that the underlying
      length limits from the DNS apply to domainparts).

   o  To avoid confusion with the term "node" as used in [<a href="#ref-XEP-0030" title="&quot;Service Discovery&quot;">XEP-0030</a>] and
      [<a href="#ref-XEP-0060" title="&quot;Publish-Subscribe&quot;">XEP-0060</a>], changed the term "node identifier" to "localpart" (but
      retained the name "Nodeprep" for backward compatibility).

   o  To avoid confusion with the terms "resource" and "identifier" as
      used in [<a href="#ref-URI" title="&quot;Uniform Resource Identifier (URI): Generic Syntax&quot;">URI</a>], changed the term "resource identifier" to
      "resourcepart".

   o  Corrected the Nameprep processing rules to require use of the
      UseSTD3ASCIIRules flag.

<span class="h2"><a class="selflink" name="appendix-D" href="#appendix-D">Appendix D</a>.  Acknowledgements</span>

   Thanks to Ben Campbell, Waqas Hussain, Jehan Pages, and Florian Zeitz
   for their feedback.  Thanks also to Richard Barnes and Elwyn Davies
   for their reviews on behalf of the Security Directorate and the
   General Area Review Team, respectively.

   The Working Group chairs were Ben Campbell and Joe Hildebrand.  The
   responsible Area Director was Gonzalo Camarillo.

   Some text in this document was borrowed or adapted from [<a href="#ref-IDNA-DEFS" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">IDNA-DEFS</a>],
   [<a href="#ref-IDNA-PROTO" title="&quot;Internationalized Domain Names in Applications (IDNA): Protocol&quot;">IDNA-PROTO</a>], [<a href="#ref-IDNA-RATIONALE" title="&quot;Internationalized Domain Names for Applications (IDNA): Background, Explanation, and Rationale&quot;">IDNA-RATIONALE</a>], and [<a href="#ref-XEP-0165" title="&quot;Best Practices to Discourage JID Mimicking&quot;">XEP-0165</a>].

Author's Address

   Peter Saint-Andre
   Cisco
   1899 Wyknoop Street, Suite 600
   Denver, CO  80202
   USA

   Phone: +1-303-308-3282
   EMail: psaintan@cisco.com







Saint-Andre                  Standards Track                   [Page 23]

</pre><br />
    <span class="noprint"><small><small>Html markup produced by rfcmarkup 1.119, available from
      <a href="https://tools.ietf.org/tools/rfcmarkup/">https://tools.ietf.org/tools/rfcmarkup/</a>
    </small></small></span>
  </div>
</body>
</html>
